unit Main;

{$mode objfpc}{$H+}

interface

uses
  Forms, Controls, Menus, ExtCtrls, Xscontrols,
  LCLType, LCLIntf, Classes, Graphics, Dialogs,
  SysUtils, FileUtil, DocManager, Clipbrd, StdCtrls,
  Buttons, ComCtrls, Opts;

const
  tb_sep = 0;
  tb_newprj = 26;   tb_openprj = 27;
  tb_new = 1;       tb_open = 2;
  tb_save = 3;      tb_saveall = 4;   tb_saveas = 5;
  tb_cut = 6;       tb_copy = 7;      tb_paste = 8;     tb_del = 9;
  tb_undo = 10;     tb_redo = 11;
  tb_find = 12;     tb_findprev = 13; tb_findnext = 14;
  tb_unindent = 15; tb_indent = 16;
  tb_setting = 17;  tb_options = 18;
  tb_build = 19;    tb_run = 20;      tb_pause = 21;    tb_stop = 22;
  tb_print = 23;    tb_color = 24;
  tb_exit = 25;

  pm_closepage = 29;pm_selall = 30;   pm_delsel = 31;
  pm_upper = 32;    pm_lower = 33;    pm_swap = 34;
  pm_titlu = 35;    pm_titll = 36;

  tlbtn : array [0..36] of smallint = (
    tb_newprj,tb_openprj,tb_sep,
    tb_new,tb_open,tb_sep,
    tb_save,tb_saveall,tb_saveas,tb_sep,
    tb_cut,tb_copy,tb_paste,tb_del,tb_sep,
    tb_undo,tb_redo,tb_sep,
    tb_find,tb_findprev,tb_findnext,tb_sep,
    tb_unindent,tb_indent,tb_sep,
    tb_setting,tb_options,tb_sep,
    tb_build,tb_run,tb_pause,tb_stop,tb_sep,
    tb_print,tb_color,tb_sep,
    tb_exit
  );

  hintname : array [0..36] of string[50] = (
    'Create new project','Open project','',
    'Create new file','Open file','',
    'Save file','Save all files','Save file as...','',
    'Cut to clipboard','Copy to clipboard','Paste from clipboard','Delete selection','',
    'Undo','Redo','',
    'Find from file','Find previous','Find next','',
    'Unindent selection','Indent selection','',
    'Project setting','Options','',
    'Build source code','Compile source code','Pause running','Stop compiling','',
    'Print file','Select color','',
    'Exit program'
  );

type

  { TForm1 }

  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Edit1: TEdit;
    Edit2: TEdit;
    ImageList1: TImageList;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuFind: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem17: TMenuItem;
    MenuClosePrj: TMenuItem;
    MenuItem19: TMenuItem;
    MenuItem24: TMenuItem;
    MenuItem25: TMenuItem;
    MenuItem28: TMenuItem;
    MenuItem29: TMenuItem;
    PTMenuSetAsMain: TMenuItem;
    PTMenuClosePrj: TMenuItem;
    PTMenuRemoveFile: TMenuItem;
    PTMenuAddFiles: TMenuItem;
    PTMenuSavePrjAs: TMenuItem;
    PTMenuSavePrj: TMenuItem;
    MenuItem23: TMenuItem;
    MenuSavePrj: TMenuItem;
    MenuSavePrjAs: TMenuItem;
    PMenuSetAsMain: TMenuItem;
    MenuItem22: TMenuItem;
    PMenuAddInPrj: TMenuItem;
    PopupMenu3: TPopupMenu;
    PPMenuAddInPrj: TMenuItem;
    PPMenuSetAsMain: TMenuItem;
    PPMenuClose: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    PMenuTitlel: TMenuItem;
    Panel5: TPanel;
    PMenuUpper: TMenuItem;
    PMenuLower: TMenuItem;
    PMenuSwap: TMenuItem;
    PMenuTitleu: TMenuItem;
    MenuItem9: TMenuItem;
    PMenuRedo: TMenuItem;
    MenuItem11: TMenuItem;
    PMenuCut: TMenuItem;
    MenuItem13: TMenuItem;
    PMenuCopy: TMenuItem;
    PMenuPaste: TMenuItem;
    PMenuDelete: TMenuItem;
    MenuItem18: TMenuItem;
    PMenuFind: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem21: TMenuItem;
    PMenuUnindent: TMenuItem;
    PMenuIndent: TMenuItem;
    PMenuSelAll: TMenuItem;
    PMenuDelSel: TMenuItem;
    MenuItem27: TMenuItem;
    MenuPrjinsp: TMenuItem;
    MenuObjinsp: TMenuItem;
    MenuMsg: TMenuItem;
    PMenuUndo: TMenuItem;
    MenuPrint: TMenuItem;
    MenuItem3: TMenuItem;
    MenuUndo: TMenuItem;
    MenuRedo: TMenuItem;
    MenuItem16: TMenuItem;
    MenuCut: TMenuItem;
    MenuCopy: TMenuItem;
    MenuPaste: TMenuItem;
    MenuNew: TMenuItem;
    MenuItem20: TMenuItem;
    MenuIndent: TMenuItem;
    MenuUnindent: TMenuItem;
    MenuDelete: TMenuItem;
    MenuPrev: TMenuItem;
    MenuNext: TMenuItem;
    MenuItem26: TMenuItem;
    MenuOpen: TMenuItem;
    MenuItem4: TMenuItem;
    MenuSave: TMenuItem;
    MenuSaveAll: TMenuItem;
    MenuSaveAs: TMenuItem;
    MenuItem8: TMenuItem;
    MenuExit: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Findpanel: TPanel;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Shape1: TShape;
    Shape2: TShape;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure  FormCreate(Sender: TObject);
    procedure  FormDestroy(Sender: TObject);
    procedure MenuItem6Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure MenuPrjinspClick(Sender: TObject);
    procedure MenuObjinspClick(Sender: TObject);
    procedure MenuMsgClick(Sender: TObject);
    procedure  MenuItemClick(Sender: TObject);
    procedure RadioButtonChange(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure ToolbarMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure  TbClick(Sender: TObject);
    procedure  ActionClick(n: integer);
    procedure  PrjAction(Sender: TObject);
  protected
    procedure  UpdateActions; override;
  private
    { private declarations }
    toolbar    : TXSToolBar;
    infopanel  : TXSPanel;
    prjtree    : TXSTreeView;
    Splitter3  : TSplitter;
    objpanel   : TXSPanel;
    toolbtn    : array [tb_sep..tb_exit] of TXSToolButton;
    function   IsInteger(s: String): boolean;
    procedure  TreePopup(Sender: TObject);
  public
    { public declarations }
    pagecontrol: TXSPagecontrol;
    prjpanel   : TXSPanel;
    document   : TXSDocManager;
    msgview    : TXSMessageView;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  png : TPortableNetworkGraphic;
  rss : TResourceStream;
  i   : integer;
  node: TTreeNode;
begin
  Doublebuffered := true;

  Width  := Screen.Width - Screen.Width div 4;
  Height := Screen.Height - Screen.Height div 4;

  png:=TPortableNetworkGraphic.Create;
  try
    rss := TResourceStream.Create(HINSTANCE,'Menu',RT_RCDATA);
    try
      png.LoadFromStream(rss);
      ImageList1.Add(png,nil);
    finally
      rss.Free;
    end;
  finally
    png.Free;
  end;

  toolbar := TXSToolBar.Create(Self);
  toolbar.Parent := Self;
  toolbar.Images := ImageList1;
  toolbar.OnMouseDown:= @ToolbarMouseDown;

  for i:=low(tlbtn) to high(tlbtn) do begin
    if tlbtn[i]=tb_sep then
      toolbar.AddSeparator
    else if tlbtn[i]=tb_color then
    else begin
      toolbtn[tlbtn[i]] := TXSToolButton.Create(toolbar);
      toolbtn[tlbtn[i]].ImageIndex := tlbtn[i]-1;
      toolbtn[tlbtn[i]].Tag        := tlbtn[i];
      toolbtn[tlbtn[i]].Enabled    := true;
      toolbtn[tlbtn[i]].OnClick    := @TbClick;
      toolbar.AddButton(hintname[i],toolbtn[tlbtn[i]]);
    end;
  end;

  findpanel.Visible:=false;

  infopanel  := TXSPanel.Create(Self);
  infopanel.Parent := Panel3;
  infopanel.Align  := alClient;
  infopanel.Images := ImageList1;
  infopanel.ImageIndex:= 28;
  infopanel.Caption   := 'Messages';

  msgview    := TXSMessageView.Create(self);
  msgview.Parent := infopanel;
  msgview.Align  := alClient;
  msgview.BorderSpacing.Top   := 27;

  Splitter3 := TSplitter.Create(self);
  Splitter3.Parent := Panel2;
  Splitter3.Align := alTop;
  Splitter3.Height:= 4;
  Splitter3.Color := clSilver;

  prjpanel  := TXSPanel.Create(Self);
  prjpanel.Parent := Panel2;
  prjpanel.Align  := alTop;
  prjpanel.Images := ImageList1;
  prjpanel.ImageIndex:= 25;
  prjpanel.Caption   := 'Project inspector';
  prjpanel.Height    := (height - Panel3.Height - toolbar.Height) div 2;

  prjtree            := TXSTreeView.Create(prjpanel);
  prjtree.parent     := prjpanel;
  prjtree.align      := alClient;
  prjtree.Images     := ImageList1;
  prjtree.BorderSpacing.Top   := 27;
  prjtree.BorderStyle:= bsNone;
  prjtree.ScrollBars := ssAutoVertical;
  prjtree.PopupMenu  := PopupMenu3;
  prjtree.PopupMenu.OnPopup:= @TreePopup;

  objpanel  := TXSPanel.Create(Self);
  objpanel.Parent := Panel2;
  objpanel.Align  := alClient;
  objpanel.Images := ImageList1;
  objpanel.ImageIndex:= 27;
  objpanel.Caption   := 'Object inspector';

  pagecontrol          := TXSpagecontrol.Create(Self);
  pagecontrol.Parent   := Panel5;
  pagecontrol.Align    := alClient;
  pagecontrol.PopupMenu:= PopupMenu2;

  document := TXSDocManager.Create(prjtree,pagecontrol);
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  CanClose := Document.SaveCloseQuery and Document.SaveCloseQueryProjects;
  if CanClose then Options.SaveSetting;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
  i: integer;
begin
  FreeAndNil(document);
  FreeAndNil(toolbar);
  for i := prjtree.items.count-1 downto 0 do begin
    Dispose(PXSTreeData(prjtree.Items.Item[i].Data));
  end;
  FreeAndNil(prjtree);
  FreeAndNil(prjpanel);
  FreeAndNil(objpanel);
  FreeAndNil(msgview);
  FreeAndNil(infopanel);
  FreeAndNil(pagecontrol);
end;

procedure TForm1.MenuItem6Click(Sender: TObject);
begin
  Document.NewSpecPage(spHexview,'Hex editor','---');
end;

procedure TForm1.MenuItem7Click(Sender: TObject);
begin
  Document.NewSpecPage(spCompare,'Files comparator','---');
end;

procedure TForm1.MenuPrjinspClick(Sender: TObject);
begin
  prjpanel.visible := true;
end;

procedure TForm1.MenuObjinspClick(Sender: TObject);
begin
  objpanel.visible := true;
end;

procedure TForm1.MenuMsgClick(Sender: TObject);
begin
  infopanel.visible := true;
end;

procedure TForm1.MenuItemClick(Sender: TObject);
begin
  ActionClick(TMenuItem(Sender).tag);
end;

procedure TForm1.RadioButtonChange(Sender: TObject);
begin
  if (Document<>NIL) and (Document.Editor<>NIL) then Document.Editor.SetFocus;
end;

function TForm1.IsInteger(s: String): boolean;
var
  i: integer;
begin
  s := Edit2.Text;
  i := 1;
  result := true;
  while (i<=length(s)) and result do begin
    result := s[i] in ['0'..'9'];
    inc(i);
  end;
  if result then
    label2.caption := upCase(IntToHex(StrToInt(Edit2.Text),8))+'H'
  else
    label2.caption := '00000000H';
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
var
  s: string;
  i,n,c,r: integer;
begin
  if document.Editor <> nil then begin
    s := document.Editor.Text;
    i:=1; c:=0; r:=0;
    n:=StrToInt(Edit2.Text);
    while (i<=length(s)) and (i<=n) do begin
      case s[i] of
        #10: begin inc(r); c:=0; end;
        #13: c := 0;
        #9 : inc(c,8);
        #32..#255: inc(c);
      end;
      inc(i);
    end;
    if (n>length(s)) and (s[i] in [#0,#10,#13]) then
      c := length(document.Editor.Lines[r-1]);
    document.Editor.CaretXY := Point(c+1,r+1);
    document.Editor.SetFocus;
    document.Editor.TopLine  := document.Editor.CaretY-(document.Editor.LinesInWindow div 4);
  end;
end;

procedure TForm1.ActionClick(n: integer);
begin
  case n of
    tb_newprj   : Document.NewProject;
    tb_openprj  : Document.OpenProject;
    tb_new      : Document.NewPage;
    tb_open     : Document.OpenPage;
    tb_save     : Document.SaveFile;
    tb_saveall  : Document.SaveAll;
    tb_saveas   : Document.SaveFileAs;
    tb_cut      : Document.Cut;
    tb_copy     : Document.Copy;
    tb_paste    : Document.Paste;
    tb_del      : Document.Delete;
    tb_undo     : Document.Undo;
    tb_redo     : Document.Redo;
    tb_find     : Document.Find;
    tb_findprev : Document.FindPrev;
    tb_findnext : Document.FindNext;
    tb_unindent : Document.Unindent;
    tb_indent   : Document.Indent;
    tb_setting  : ;
    tb_options  : Options.ShowModal;
    tb_build    : Document.Build;
    tb_run      : Document.Run;
    tb_pause    : Document.Pause;
    tb_stop     : Document.Stop;
    tb_print    :;
    tb_exit     : Close;

    pm_closepage: Document.ClosePage;
    pm_selall   : Document.SelectAll;
    pm_delsel   : Document.DeleteSelection;
    pm_upper    : Document.Upper;
    pm_lower    : Document.Lower;
    pm_swap     : Document.Swap;
    pm_titlu    : Document.TitleUp;
    pm_titll    : Document.TitleLo;
  else
    ShowMessage(IntToStr(n));
  end;
end;

procedure TForm1.ToolbarMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Sender IS TXSToolBar) or (Sender IS TXSToolButton) then begin
    if Document.Editor<>nil then
      Document.Editor.SetFocus
    else
      TXSToolBar(Sender).SetFocus;
    Invalidate;
  end;
end;

procedure TForm1.TbClick(Sender: TObject);
begin
  if Sender IS TXSToolButton then ActionClick(TXSToolButton(Sender).tag);
end;

procedure TForm1.TreePopup(Sender: TObject);
var
  prjname: string;
begin
  if prjtree.ActiveNode <> nil then begin
    prjname := ExtractFileName(prjtree.ActiveNode.text);
    PTMenuClosePrj.Caption:='Close project "'+prjname+'"';
    PTMenuSavePrj.Caption:='Save project "'+prjname+'"';
    PTMenuSavePrjAs.Caption:='Save project "'+prjname+'" as...';
    PTMenuAddFiles.Caption := 'Add files in project "'+prjname+'"';
    if prjtree.ActiveChild <> nil then begin
      PTMenuSetAsMain.Enabled := true;
      PTMenuSetAsMain.Caption := 'Set as main module "'+ExtractFileName(prjtree.ActiveChild.text)+'" in "'+prjname+'"';
      PTMenuRemoveFile.Enabled := true;
      PTMenuRemoveFile.Caption := 'Remove file "'+ExtractFileName(prjtree.ActiveChild.text)+'" from "'+prjname+'"';
    end else begin
      PTMenuRemoveFile.Enabled := false;
      PTMenuRemoveFile.Caption := 'Remove file';
      PTMenuSetAsMain.Enabled  := false;
      PTMenuSetAsMain.Caption  := 'Set as main module';
    end;
  end else begin
    PTMenuClosePrj.Caption:='Close active project';
    PTMenuSavePrj.Caption:='Save active project';
    PTMenuSavePrjAs.Caption:='Save active project as...';
    PTMenuAddFiles.Caption := 'Add files in active project';
    prjtree.ActiveChild := nil;
    PTMenuRemoveFile.Enabled := false;
    PTMenuRemoveFile.Caption := 'Remove file';
    PTMenuSetAsMain.Enabled  := false;
    PTMenuSetAsMain.Caption  := 'Set as main module';
  end;
end;

procedure TForm1.PrjAction(Sender: TObject);
begin
  if Sender is TMenuItem then
    case TMenuItem(Sender).tag of
      0: document.PopupClosePage;
      1: document.PopupAddInPrj;
      2: document.PopupSetAsMain;
      3:
         begin
           pagecontrol.popupidx := pagecontrol.ActivePage;
           document.PopupClosePage;
           pagecontrol.popupidx := -1;
         end;
      4:
         begin
           pagecontrol.popupidx := pagecontrol.ActivePage;
           document.PopupAddInPrj;
           pagecontrol.popupidx := -1;
         end;
      5:
         begin
           pagecontrol.popupidx := pagecontrol.ActivePage;
           document.PopupSetAsMain;
           pagecontrol.popupidx := -1;
         end;
      6: document.SaveProject;
      7: document.SaveProjectAs;
      8: document.CloseProject;
      9: document.SaveProjectFromMenu;
      10: document.SaveProjectAsFromMenu;
      11: document.AddFilesInPrj;
      12: document.RemoveFileInPrj;
      13: document.SetAsMainFromMenu;
    end;
end;

procedure TForm1.UpdateActions;
var
  flag: boolean;
begin

  flag := document.Editor <> nil;

  toolbtn[tb_save].enabled     := flag and not Document.TabIsSpecial and (Document.Editor.Modified or (Document.TabPath=''));
  toolbtn[tb_saveall].enabled  := flag and (Document.PageCount>1) and Document.AllModified;
  toolbtn[tb_saveas].enabled   := flag and not Document.TabIsSpecial;

  toolbtn[tb_cut].enabled      := flag and Document.Editor.SelAvail;
  toolbtn[tb_copy].enabled     := flag and Document.Editor.SelAvail;
  toolbtn[tb_paste].enabled    := flag and (Clipboard.AsText<>'');
  toolbtn[tb_del].enabled      := flag and Document.Editor.SelAvail;

  toolbtn[tb_undo].enabled     := flag and Document.Editor.CanUndo;
  toolbtn[tb_redo].enabled     := flag and Document.Editor.CanRedo;

  toolbtn[tb_find].enabled     := flag and (Document.Editor.Text<>'');
  toolbtn[tb_findprev].enabled := flag and (Edit1.Text<>'');
  toolbtn[tb_findnext].enabled := flag and (Edit1.Text<>'');

  toolbtn[tb_unindent].enabled := flag and Document.Editor.SelAvail;
  toolbtn[tb_indent].enabled   := flag and Document.Editor.SelAvail;

  toolbtn[tb_build].enabled    := false;
  toolbtn[tb_run].enabled      := true;
  toolbtn[tb_pause].enabled    := false;
  toolbtn[tb_stop].enabled     := false;

  toolbtn[tb_print].enabled    := false;

  PMenucut.enabled             := toolbtn[tb_cut].enabled;
  PMenucopy.enabled            := toolbtn[tb_copy].enabled;
  PMenupaste.enabled           := toolbtn[tb_paste].enabled;
  PMenudelete.enabled          := toolbtn[tb_del].enabled;
  PMenuundo.enabled            := toolbtn[tb_undo].enabled;
  PMenuredo.enabled            := toolbtn[tb_redo].enabled;
  PMenufind.enabled            := toolbtn[tb_find].enabled;
  PMenuunindent.enabled        := toolbtn[tb_unindent].enabled;
  PMenuindent.enabled          := toolbtn[tb_indent].enabled;

  PMenuSelAll.enabled          := flag and (Document.Editor.Text<>'');
  PMenuDelSel.enabled          := flag and Document.Editor.SelAvail;

  PMenuUpper.enabled           := flag and Document.Editor.SelAvail;
  PMenuLower.enabled           := flag and Document.Editor.SelAvail;
  PMenuSwap.enabled            := flag and Document.Editor.SelAvail;
  PMenuTitleu.enabled          := flag and Document.Editor.SelAvail;
  PMenuTitlel.enabled          := flag and Document.Editor.SelAvail;

  if not flag then begin
    findpanel.Visible := false;
    Edit1.Text := '';
    Edit2.Text := '';
  end;

  toolbtn[tb_new].enabled     := true;
  toolbtn[tb_open].enabled    := true;
  toolbtn[tb_options].enabled := true;
  toolbtn[tb_exit].enabled    := true;

  MenuSave.enabled            := toolbtn[tb_save].enabled;
  MenuSaveall.enabled         := toolbtn[tb_saveall].enabled;
  MenuSaveas.enabled          := toolbtn[tb_saveas].enabled;
  Menuprint.enabled           := toolbtn[tb_print].enabled;

  Menucut.enabled             := toolbtn[tb_cut].enabled;
  Menucopy.enabled            := toolbtn[tb_copy].enabled;
  Menupaste.enabled           := toolbtn[tb_paste].enabled;
  Menudelete.enabled          := toolbtn[tb_del].enabled;
  Menuundo.enabled            := toolbtn[tb_undo].enabled;
  Menuredo.enabled            := toolbtn[tb_redo].enabled;
  Menufind.enabled            := toolbtn[tb_find].enabled;
  Menuprev.enabled            := toolbtn[tb_findprev].enabled;
  Menunext.enabled            := toolbtn[tb_findnext].enabled;
  Menuunindent.enabled        := toolbtn[tb_unindent].enabled;
  Menuindent.enabled          := toolbtn[tb_indent].enabled;

  MenuPrjinsp.enabled         := not prjpanel.visible;
  MenuObjinsp.enabled         := not objpanel.visible;
  MenuMsg.enabled             := not infopanel.visible;

  Panel3.Visible              := infopanel.Visible;
  Splitter1.Visible           := Panel3.Visible;

  Panel2.Visible              := prjpanel.Visible or objpanel.Visible;
  Splitter3.Visible           := prjpanel.Visible and objpanel.Visible;
  Splitter2.Visible           := Panel2.Visible;

  SpeedButton1.Enabled        := toolbtn[tb_findprev].enabled;
  SpeedButton2.Enabled        := toolbtn[tb_findnext].enabled;
  SpeedButton3.Enabled        := (Edit2.Text<>'') and IsInteger(Edit2.Text);

  flag := prjtree.Items.Count>0;

  toolbtn[tb_setting].enabled := flag;

  MenuSavePrj.Enabled   := flag and Document.PrjIsModified(true);
  MenuSavePrjAs.Enabled := flag;
  MenuClosePrj.enabled  := flag;

  if not flag then begin
    //prjtree.PopupMenu  := nil;
  end else
    ;//prjtree.PopupMenu  := PopupMenu3;

  PTMenuClosePrj.Enabled   := flag;
  PTMenuSavePrj.Enabled    := flag and Document.PrjIsModified(false);
  PTMenuSavePrjAs.Enabled  := flag;
  PTMenuAddFiles.Enabled   := flag;

  PPMenuAddInPrj.enabled := flag;
  PPMenuSetAsMain.enabled := flag and (prjtree.ActivePrj.Count>0);
  PMenuAddInPrj.enabled := flag;
  PMenuSetAsMain.enabled := flag and (prjtree.ActivePrj.Count>0);
end;

end.

