unit Opts;

{$mode objfpc}{$H+}

interface

uses
  Classes, Forms, SysUtils, Graphics, Controls, ExtCtrls, StdCtrls, Grids,
  ColorBox, ComCtrls, SynEdit, SynGutter, SynGutterCodeFolding,
  SynHighlighterObr, SynGutterLineNumber, SynEditMarkupHighAll,
  SynEditHighlighter, Dialogs, Buttons, DOM, XMLWrite, XMLRead;

type

  { TOptions }

  TOptions = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    Button2: TButton;
    Button3: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    ColorBox1: TColorBox;
    ColorBox10: TColorBox;
    ColorBox11: TColorBox;
    ColorBox2: TColorBox;
    ColorBox3: TColorBox;
    ColorBox4: TColorBox;
    ColorBox5: TColorBox;
    ColorBox6: TColorBox;
    ColorBox7: TColorBox;
    ColorBox8: TColorBox;
    ColorBox9: TColorBox;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    StringGrid1: TStringGrid;
    SynEdit1: TSynEdit;
    TreeView1: TTreeView;
    TreeView2: TTreeView;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure DefaultClick(Sender: TObject);
    procedure ColorBoxGeneralChange(Sender: TObject);
    procedure OkClick(Sender: TObject);
    procedure CheckBoxChange(Sender: TObject);
    procedure ColorBox1Change(Sender: TObject);
    procedure ColorBox2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure TreeView2Change(Sender: TObject; Node: TTreeNode);
  private
    { private declarations }
    procedure ShowPanel(n: integer);
  public
    { public declarations }
    Highlighter: TSynObrSyn;
    procedure   SaveSetting;
    function    LoadSetting: boolean;
  end;

var
  Options: TOptions;

implementation

uses
  Main;

{$R *.lfm}

{ TOptions }

procedure TOptions.FormCreate(Sender: TObject);
var
  i,j: integer;
  f: boolean;
begin

  Highlighter := TSynObrSyn.Create(self);
  SynEdit1.Highlighter := Highlighter;

  f := LoadSetting;

  width := 580;
  height := 410;
  font.size := 8;

  Panel1.width := 405;
  Panel1.align := alRight;
  Panel2.width := 405;
  Panel2.align := alRight;
  Panel3.width := 405;
  Panel3.align := alRight;

  if not f then begin
    Edit1.Text := ExtractFilePath(ParamStr(0));
    Edit2.Text := ExtractFilePath(ParamStr(0))+'Source'+DirectorySeparator;
    Edit3.Text := 'Module';
    Edit4.Text := '.mod';
    Edit6.Text := 'Project';
    Edit5.Text := '.opr';
    for i:=1 to StringGrid1.RowCount-1 do StringGrid1.Rows[i].Add(IntToStr(i));
    StringGrid1.Cells[1,1] := 'Oberon files (*.mod;*.ob7)'; StringGrid1.Cells[2,1] := '*.mod;*.ob7';
    StringGrid1.Cells[1,2] := 'Oberon project files (*.opr)';    StringGrid1.Cells[2,2] := '*.opr';
    StringGrid1.Cells[1,3] := 'Text files (*.txt;*.ini;*.inc)';   StringGrid1.Cells[2,3] := '*.txt;*.ini;*.inc';
    StringGrid1.Cells[1,4] := 'All files (*.*)';                  StringGrid1.Cells[2,4] := '*.*';

    ColorBox3.Selected := $0000FF;
    ColorBox4.Selected := $DDFFFF;
    ColorBox5.Selected := $A56D53;
    ColorBox6.Selected := $E5E5E5;

    ColorBox7.Selected := clGray;
    ColorBox8.Selected := $E5E5E5;

    ColorBox9.Selected := clGray;
    ColorBox10.Selected := $E5E5E5;
    ColorBox11.Selected := 0;
    Combobox2.ItemIndex := 3;
  end;

  Form1.document.DefModName:= Edit3.Text;
  Form1.document.DefModExt := Edit4.Text;
  Form1.document.DefPrjName:= Edit6.Text;
  Form1.document.DefPrjExt := Edit5.Text;
  Form1.document.FileFilter := '';

  for i:=1 to StringGrid1.RowCount-1 do
    for j:=1 to StringGrid1.ColCount-1 do
      Form1.document.FileFilter := Form1.document.FileFilter + StringGrid1.Cells[j,i]+'|';

  StringGrid1.ColWidths[0] := 25;
  StringGrid1.ColWidths[1] := (StringGrid1.width - StringGrid1.ColWidths[0]) div 2;
  StringGrid1.ColWidths[2] := (StringGrid1.width - StringGrid1.ColWidths[0]) div 2 - 1;

  SynEdit1.BracketMatchColor.Foreground  := ColorBox3.Selected;
  SynEdit1.LineHighlightColor.Background := ColorBox4.Selected;
  SynEdit1.SelectedColor.Background      := ColorBox5.Selected;
  SynEdit1.Gutter.Color                  := ColorBox6.Selected;

  TSynGutterLineNumber(SynEdit1.Gutter.Parts.Part[1]).ShowOnlyLineNumbersMultiplesOf:=5;
  TSynGutterLineNumber(SynEdit1.Gutter.Parts.Part[1]).MarkupInfo.Foreground:=ColorBox7.Selected; //Цыфры
  TSynGutterLineNumber(SynEdit1.Gutter.Parts.Part[1]).MarkupInfo.Background:=ColorBox8.Selected;
  TSynGutterSeparator(SynEdit1.Gutter.Parts.Part[3]).MarkupInfo.Foreground:=SynEdit1.Color;  //Разделитель
  TSynGutterCodeFolding(SynEdit1.Gutter.Parts.Part[4]).MarkupInfo.Foreground:=ColorBox9.Selected;
  TSynGutterCodeFolding(SynEdit1.Gutter.Parts.Part[4]).MarkupInfo.Background:=ColorBox10.Selected;
  SynEdit1.FoldedCodeColor.FrameColor:=ColorBox11.Selected;

  TreeView2.align := alClient;
  TreeView2.Select(TreeView2.Items.Item[1]);
  TreeView1.Select(TreeView1.Items.Item[1]);
end;

procedure TOptions.FormDestroy(Sender: TObject);
begin
  Highlighter.free;
end;

procedure TOptions.SaveSetting;
var
  Doc: TXMLDocument;
  RootNode, ElementNode,SubNode,ItemNode,TextNode: TDOMNode;
  i,j: integer;
  stl: set of 0..3;
  Attri: TSynHighlighterAttributes;

  procedure CreateSingle(var Element: TDOMNode; name,value: string);
  begin
    ItemNode:=Doc.CreateElement(name);
    TextNode:=Doc.CreateTextNode(value);
    ItemNode.AppendChild(TextNode);
    Element.AppendChild(ItemNode);
  end;

begin
  try
    Doc := TXMLDocument.Create;
    RootNode := Doc.CreateElement('Options');
    Doc.Appendchild(RootNode);
    RootNode:= Doc.DocumentElement;

    ElementNode:=Doc.CreateElement('General');
      CreateSingle(ElementNode,'Language'      ,'ru');
      CreateSingle(ElementNode,'MainDiectory'  ,Edit1.Text);
      CreateSingle(ElementNode,'SourceDiectory',Edit2.Text);
      CreateSingle(ElementNode,'DefaultModule' ,Edit3.Text);
      CreateSingle(ElementNode,'DefaultExt'    ,Edit4.Text);
      CreateSingle(ElementNode,'DefaultProject',Edit6.Text);
      CreateSingle(ElementNode,'ProjectExt'   ,Edit5.Text);

      SubNode:=Doc.CreateElement('Filters');
      for i:=1 to StringGrid1.RowCount-1 do
        for j:=1 to StringGrid1.ColCount-1 do begin
          ItemNode:=Doc.CreateElement('Item');
          TextNode:=Doc.CreateTextNode(StringGrid1.Cells[j,i]);
          ItemNode.AppendChild(TextNode);
          SubNode.AppendChild(ItemNode);
        end;
      TDOMElement(SubNode).SetAttribute('Cols', IntToStr(j));
      TDOMElement(SubNode).SetAttribute('Rows', IntToStr(i));
      ElementNode.AppendChild(SubNode);

    RootNode.AppendChild(ElementNode);


    ElementNode:=Doc.CreateElement('Editor');
    CreateSingle(ElementNode,'Tabwidth'  ,IntToStr(Combobox2.ItemIndex));
    CreateSingle(ElementNode,'Bracket'  ,ColorToString(ColorBox3.Selected));
    CreateSingle(ElementNode,'Linehighlight'  ,ColorToString(ColorBox4.Selected));
    CreateSingle(ElementNode,'Selected'  ,ColorToString(ColorBox5.Selected));
    CreateSingle(ElementNode,'Gutter'  ,ColorToString(ColorBox6.Selected));

    ItemNode:=Doc.CreateElement('Number');
    TDOMElement(ItemNode).SetAttribute('background', ColorToString(ColorBox7.Selected));
    TDOMElement(ItemNode).SetAttribute('foreground', ColorToString(ColorBox8.Selected));
    ElementNode.AppendChild(ItemNode);

    ItemNode:=Doc.CreateElement('Folding');
    TDOMElement(ItemNode).SetAttribute('background', ColorToString(ColorBox9.Selected));
    TDOMElement(ItemNode).SetAttribute('foreground', ColorToString(ColorBox10.Selected));
    TDOMElement(ItemNode).SetAttribute('frame'     , ColorToString(ColorBox11.Selected));
    ElementNode.AppendChild(ItemNode);

    for i := 0 to 13 do begin
      ItemNode:=Doc.CreateElement('Attributes');

      case i of
        0 : Attri := Highlighter.IdentifierAttri;
        1 : Attri := Highlighter.CommentAttri;
        2 : Attri := Highlighter.HexAttri;
        3 : Attri := Highlighter.DirectiveAttri;
        4 : Attri := Highlighter.KeyAttri;
        5 : Attri := Highlighter.TypAttri;
        6 : Attri := Highlighter.SysAttri;
        7 : Attri := Highlighter.ModAttri;
        8 : Attri := Highlighter.NumberAttri;
        9 : Attri := Highlighter.SpaceAttri;
        10: Attri := Highlighter.StringAttri;
        11: Attri := Highlighter.AnsiStringAttri;
        12: Attri := Highlighter.SymbolAttri;
        13: Attri := Highlighter.SpecialAttri;
      end;

      TDOMElement(ItemNode).SetAttribute('background', ColorToString(Attri.Background));
      TDOMElement(ItemNode).SetAttribute('foreground', ColorToString(Attri.Foreground));

      stl := [];
      if fsUnderline in Attri.Style then stl := stl + [1];
      if fsBold      in Attri.Style then stl := stl + [2];
      if fsItalic    in Attri.Style then stl := stl + [3];
      TDOMElement(ItemNode).SetAttribute('style',IntToStr(integer(stl)));

      TextNode:=Doc.CreateTextNode(Attri.Name);

      ItemNode.AppendChild(TextNode);
      ElementNode.AppendChild(ItemNode);
    end;
    RootNode.AppendChild(ElementNode);

    WriteXMLFile(Doc,'cfg.xml');
  finally
    Doc.Free;
  end;
end;

function TOptions.LoadSetting: boolean;
type
  tset = set of 0..3;
var
  iNode, cNode: TDOMNode;
  Doc: TXMLDocument;
  i,j,row,col: integer;
  stl: tset;
  Attri: TSynHighlighterAttributes;
begin
  result := false;
  if FileExists('cfg.xml') then begin
    ReadXMLFile(Doc, 'cfg.xml');
    iNode := Doc.DocumentElement.FirstChild;
    iNode := iNode.FirstChild;

    if iNode.NodeName='Language' then begin

      iNode := iNode.NextSibling;
    end;

    if iNode.NodeName='MainDiectory' then begin
      Edit1.Text := iNode.FirstChild.NodeValue;
      iNode := iNode.NextSibling;
    end;

    if iNode.NodeName='SourceDiectory' then begin
      Edit2.Text := iNode.FirstChild.NodeValue;
      iNode := iNode.NextSibling;
    end;

    if iNode.NodeName='DefaultModule' then begin
      Edit3.Text := iNode.FirstChild.NodeValue;
      iNode := iNode.NextSibling;
    end;

    if iNode.NodeName='DefaultExt' then begin
      Edit4.Text := iNode.FirstChild.NodeValue;
      iNode := iNode.NextSibling;
    end;

    if iNode.NodeName='DefaultProject' then begin
      Edit6.Text := iNode.FirstChild.NodeValue;
      iNode := iNode.NextSibling;
    end;

    if iNode.NodeName='ProjectExt' then begin
      Edit5.Text := iNode.FirstChild.NodeValue;
      iNode := iNode.NextSibling;
    end;

    if iNode.NodeName='Filters' then begin
      if iNode.HasAttributes and (iNode.Attributes.Length>0) then begin
        col := StrToInt(iNode.Attributes[0].NodeValue);
        row := StrToInt(iNode.Attributes[1].NodeValue);
        cNode := iNode.FirstChild;
        for i:=1 to row do StringGrid1.Rows[i].Add(IntToStr(i));
        for i:=1 to row do
          for j:=1 to col do begin
            StringGrid1.Cells[j,i] := cNode.FirstChild.NodeValue;
            cNode := cNode.NextSibling;
          end;
      end;
      iNode := iNode.NextSibling;
    end;

    iNode := Doc.DocumentElement.FirstChild;
    iNode := iNode.NextSibling;
    cNode := iNode.FirstChild;

    if cNode.NodeName='Tabwidth' then begin
      Combobox2.ItemIndex := StrToInt(cNode.FirstChild.NodeValue);
      cNode := cNode.NextSibling;
    end;

    if cNode.NodeName='Bracket' then begin
      ColorBox3.Selected := StringToColor(cNode.FirstChild.NodeValue);
      cNode := cNode.NextSibling;
    end;

    if cNode.NodeName='Linehighlight' then begin
      ColorBox4.Selected := StringToColor(cNode.FirstChild.NodeValue);
      cNode := cNode.NextSibling;
    end;

    if cNode.NodeName='Selected' then begin
      ColorBox5.Selected := StringToColor(cNode.FirstChild.NodeValue);
      cNode := cNode.NextSibling;
    end;

    if cNode.NodeName='Gutter' then begin
      ColorBox6.Selected := StringToColor(cNode.FirstChild.NodeValue);
      cNode := cNode.NextSibling;
    end;

    if cNode.NodeName='Number' then begin
      ColorBox7.Selected := StringToColor(cNode.Attributes[0].NodeValue);
      ColorBox8.Selected := StringToColor(cNode.Attributes[1].NodeValue);
      cNode := cNode.NextSibling;
    end;

    if cNode.NodeName='Folding' then begin
      ColorBox9.Selected := StringToColor(cNode.Attributes[1].NodeValue);
      ColorBox10.Selected := StringToColor(cNode.Attributes[2].NodeValue);
      ColorBox11.Selected := StringToColor(cNode.Attributes[0].NodeValue);
      cNode := cNode.NextSibling;
    end;

    for i := 0 to 13 do begin
      if cNode.HasAttributes and (cNode.Attributes.Length>0) then begin
        case i of
          0 : Attri := Highlighter.IdentifierAttri;
          1 : Attri := Highlighter.CommentAttri;
          2 : Attri := Highlighter.HexAttri;
          3 : Attri := Highlighter.DirectiveAttri;
          4 : Attri := Highlighter.KeyAttri;
          5 : Attri := Highlighter.TypAttri;
          6 : Attri := Highlighter.SysAttri;
          7 : Attri := Highlighter.ModAttri;
          8 : Attri := Highlighter.NumberAttri;
          9 : Attri := Highlighter.SpaceAttri;
          10: Attri := Highlighter.StringAttri;
          11: Attri := Highlighter.AnsiStringAttri;
          12: Attri := Highlighter.SymbolAttri;
          13: Attri := Highlighter.SpecialAttri;
        end;

        stl := tset(StrToInt(cNode.Attributes[0].NodeValue));
        Attri.Style := [];
        if 1 in stl then Attri.Style := Attri.Style + [fsUnderline];
        if 2 in stl then Attri.Style := Attri.Style + [fsBold];
        if 3 in stl then Attri.Style := Attri.Style + [fsItalic];

        Attri.Background:= StringToColor(cNode.Attributes[1].NodeValue);
        Attri.Foreground:= StringToColor(cNode.Attributes[2].NodeValue);

        cNode := cNode.NextSibling;
      end;
    end;

    Doc.Free;
    result := true;
  end;
end;

procedure TOptions.CheckBoxChange(Sender: TObject);
var
  Node: TTreeNode;
  Attri: TSynHighlighterAttributes;
begin
  Node := TreeView1.Selected;

  case Node.Index of
    0: Attri := Highlighter.IdentifierAttri;
    1: Attri := Highlighter.CommentAttri;
    2: Attri := Highlighter.HexAttri;
    3: Attri := Highlighter.DirectiveAttri;
    4: Attri := Highlighter.KeyAttri;
    5: Attri := Highlighter.TypAttri;
    6: Attri := Highlighter.SysAttri;
    7: Attri := Highlighter.ModAttri;
    8: Attri := Highlighter.NumberAttri;
    9: Attri := Highlighter.SpaceAttri;
    10: Attri := Highlighter.StringAttri;
    11: Attri := Highlighter.AnsiStringAttri;
    12: Attri := Highlighter.SymbolAttri;
    13: Attri := Highlighter.SpecialAttri;
  else
    Attri := nil;
  end;

  if Attri<>nil then begin
    if Sender is TCheckBox then begin

      if TCheckBox(Sender).checked then
        case TCheckBox(Sender).tag of
          1: Attri.Style := Attri.Style + [fsUnderline];
          2: Attri.Style := Attri.Style + [fsBold];
          3: Attri.Style := Attri.Style + [fsItalic];
        end;

      if not TCheckBox(Sender).checked then
        case TCheckBox(Sender).tag of
          1: Attri.Style := Attri.Style - [fsUnderline];
          2: Attri.Style := Attri.Style - [fsBold];
          3: Attri.Style := Attri.Style - [fsItalic];
        end;

    end;
  end;
  SynEdit1.Invalidate;
  Main.Form1.Invalidate;
end;

procedure TOptions.DefaultClick(Sender: TObject);
var
  i: integer;
begin
  case TButton(Sender).tag of
    9:
          begin
            Edit1.Text := ExtractFilePath(ParamStr(0));
            Edit2.Text := ExtractFilePath(ParamStr(0))+'Source'+DirectorySeparator;
            Edit3.Text := 'Module';
            Edit4.Text := '.mod';
            for i:=1 to StringGrid1.RowCount-1 do StringGrid1.Rows[i].Add(IntToStr(i));
            StringGrid1.Cells[1,1] := 'Oberon files (*.mod;*.ob7)';     StringGrid1.Cells[2,1] := '*.mod;*.ob7';
            StringGrid1.Cells[1,2] := 'Oberon project files (*.opr)';   StringGrid1.Cells[2,2] := '*.opr';
            StringGrid1.Cells[1,3] := 'Text files (*.txt;*.ini;*.inc)'; StringGrid1.Cells[2,3] := '*.txt;*.ini;*.inc';
            StringGrid1.Cells[1,4] := 'All files (*.*)';                StringGrid1.Cells[2,4] := '*.*';
          end;
    10:
          begin
            ColorBox3.Selected := $0000FF;
            ColorBox4.Selected := $DDFFFF;
            ColorBox5.Selected := $A56D53;
            ColorBox6.Selected := $E5E5E5;

            ColorBox7.Selected := clGray;
            ColorBox8.Selected := $E5E5E5;

            ColorBox9.Selected := clGray;
            ColorBox10.Selected := $E5E5E5;
            ColorBox11.Selected := 0;
            Combobox2.ItemIndex := 3;
          end;
    11:
          begin
            Highlighter.IdentifierAttri.Style     := [];
            Highlighter.IdentifierAttri.Foreground := clBlack;
            Highlighter.IdentifierAttri.Background := clWhite;

            Highlighter.CommentAttri.Style:= [fsItalic];
            Highlighter.CommentAttri.Foreground := clGray;
            Highlighter.CommentAttri.Background := clWhite;

            Highlighter.HexAttri.Style:= [];
            Highlighter.HexAttri.Background := clWhite;
            Highlighter.HexAttri.Foreground := clGreen;

            Highlighter.DirectiveAttri.Style:= [fsBold];
            Highlighter.DirectiveAttri.Background := clWhite;
            Highlighter.DirectiveAttri.Foreground := clTeal;

            Highlighter.KeyAttri.Style     := [fsBold];
            Highlighter.KeyAttri.Background := clWhite;
            Highlighter.KeyAttri.Foreground := clNavy;

            Highlighter.TypAttri.Style     := [fsBold];
            Highlighter.TypAttri.Background := clWhite;
            Highlighter.TypAttri.Foreground := clGreen;

            Highlighter.SysAttri.Style     := [fsBold];
            Highlighter.SysAttri.Background := clWhite;
            Highlighter.SysAttri.Foreground := $0000BB;

            Highlighter.ModAttri.Style     := [fsBold];
            Highlighter.ModAttri.Background := clWhite;
            Highlighter.ModAttri.Foreground := clBlack;

            Highlighter.NumberAttri.Style     := [];
            Highlighter.NumberAttri.Background := clWhite;
            Highlighter.NumberAttri.Foreground := $00996600;

            Highlighter.SpaceAttri.Style     := [];
            Highlighter.SpaceAttri.Background := clWhite;
            Highlighter.SpaceAttri.Foreground := clWhite;

            Highlighter.StringAttri.Style:= [fsBold];
            Highlighter.StringAttri.Background := clWhite;
            Highlighter.StringAttri.Foreground:=clMaroon;

            Highlighter.AnsiStringAttri.Style:= [fsBold];
            Highlighter.AnsiStringAttri.Background := clWhite;
            Highlighter.AnsiStringAttri.Foreground:=$005500CC;

            Highlighter.SymbolAttri.Style:= [];
            Highlighter.SymbolAttri.Background := clWhite;
            Highlighter.SymbolAttri.Foreground := $00996600;

            Highlighter.SpecialAttri.Style     := [fsBold];
            Highlighter.SpecialAttri.Background := clWhite;
            Highlighter.SpecialAttri.Foreground := $002288;

            TreeView1Change(TreeView1,TreeView1.Selected);
            if (Main.Form1.document<>nil) and (Main.Form1.document.Editor<>nil) then Main.Form1.document.Editor.Invalidate;
            SynEdit1.Invalidate;
          end;

  end;
end;

procedure TOptions.OkClick(Sender: TObject);
begin
  SaveSetting;
  Close;
end;

procedure TOptions.ColorBoxGeneralChange(Sender: TObject);
begin
  case TColorBox(Sender).tag of
    1: SynEdit1.BracketMatchColor.Foreground  := ColorBox3.Selected;
    2: SynEdit1.LineHighlightColor.Background := ColorBox4.Selected;
    3: SynEdit1.SelectedColor.Background      := ColorBox5.Selected;
    4: SynEdit1.Gutter.Color                  := ColorBox6.Selected;
    5: TSynGutterLineNumber(SynEdit1.Gutter.Parts.Part[1]).MarkupInfo.Foreground:=ColorBox7.Selected;
    6: TSynGutterLineNumber(SynEdit1.Gutter.Parts.Part[1]).MarkupInfo.Background:=ColorBox8.Selected;
    7: TSynGutterCodeFolding(SynEdit1.Gutter.Parts.Part[4]).MarkupInfo.Foreground:=ColorBox9.Selected;
    8: TSynGutterCodeFolding(SynEdit1.Gutter.Parts.Part[4]).MarkupInfo.Background:=ColorBox10.Selected;
    9: SynEdit1.FoldedCodeColor.FrameColor:=ColorBox11.Selected;
  end;
  SynEdit1.Invalidate;
  if (Main.Form1.document<>nil) and (Main.Form1.document.Editor<>nil) then begin
    Main.Form1.document.Editor.BracketMatchColor.Foreground  := ColorBox3.Selected;
    Main.Form1.document.Editor.LineHighlightColor.Background := ColorBox4.Selected;
    Main.Form1.document.Editor.SelectedColor.Background      := ColorBox5.Selected;
    Main.Form1.document.Editor.Gutter.Color                  := ColorBox6.Selected;
    TSynGutterLineNumber(Main.Form1.document.Editor.Gutter.Parts.Part[1]).MarkupInfo.Foreground:=ColorBox7.Selected;
    TSynGutterLineNumber(Main.Form1.document.Editor.Gutter.Parts.Part[1]).MarkupInfo.Background:=ColorBox8.Selected;
    TSynGutterCodeFolding(Main.Form1.document.Editor.Gutter.Parts.Part[4]).MarkupInfo.Foreground:=ColorBox9.Selected;
    TSynGutterCodeFolding(Main.Form1.document.Editor.Gutter.Parts.Part[4]).MarkupInfo.Background:=ColorBox10.Selected;
    Main.Form1.document.Editor.FoldedCodeColor.FrameColor:=ColorBox11.Selected;
    Main.Form1.document.Editor.Invalidate;
  end;
end;

procedure TOptions.ColorBox1Change(Sender: TObject);
var
  Node: TTreeNode;
begin
  Node := TreeView1.Selected;
  case Node.Index of
    0: Highlighter.IdentifierAttri.Foreground := ColorBox1.Selected;
    1: Highlighter.CommentAttri.Foreground := ColorBox1.Selected;
    2: Highlighter.HexAttri.Foreground := ColorBox1.Selected;
    3: Highlighter.DirectiveAttri.Foreground := ColorBox1.Selected;
    4: Highlighter.KeyAttri.Foreground := ColorBox1.Selected;
    5: Highlighter.TypAttri.Foreground := ColorBox1.Selected;
    6: Highlighter.SysAttri.Foreground := ColorBox1.Selected;
    7: Highlighter.ModAttri.Foreground := ColorBox1.Selected;
    8: Highlighter.NumberAttri.Foreground := ColorBox1.Selected;
    10: Highlighter.StringAttri.Foreground := ColorBox1.Selected;
    11: Highlighter.AnsiStringAttri.Foreground := ColorBox1.Selected;
    12: Highlighter.SymbolAttri.Foreground := ColorBox1.Selected;
    13: Highlighter.SpecialAttri.Foreground := ColorBox1.Selected;
  end;
  SynEdit1.Invalidate;
  Main.Form1.Invalidate;
end;

procedure TOptions.ColorBox2Change(Sender: TObject);
var
  Node: TTreeNode;
begin
  Node := TreeView1.Selected;
  case Node.Index of
    0: Highlighter.IdentifierAttri.Background := ColorBox2.Selected;
    1: Highlighter.CommentAttri.Background := ColorBox2.Selected;
    2: Highlighter.HexAttri.Background := ColorBox2.Selected;
    3: Highlighter.DirectiveAttri.Background := ColorBox2.Selected;
    4: Highlighter.KeyAttri.Background := ColorBox2.Selected;
    5: Highlighter.TypAttri.Background := ColorBox2.Selected;
    6: Highlighter.SysAttri.Background := ColorBox2.Selected;
    7: Highlighter.ModAttri.Background := ColorBox2.Selected;
    8: Highlighter.NumberAttri.Background := ColorBox2.Selected;
    9: Highlighter.SpaceAttri.Background := ColorBox2.Selected;
    10: Highlighter.StringAttri.Background := ColorBox2.Selected;
    11: Highlighter.AnsiStringAttri.Background := ColorBox2.Selected;
    12: Highlighter.SymbolAttri.Background := ColorBox2.Selected;
    13: Highlighter.SpecialAttri.Background := ColorBox2.Selected;
  end;
  SynEdit1.Invalidate;
  Main.Form1.Invalidate;
end;

procedure TOptions.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
  //ShowMessage(IntToStr(Node.Index));
  case Node.Index of
    0:
        begin
          ColorBox1.Selected := Highlighter.IdentifierAttri.Foreground;
          ColorBox2.Selected := Highlighter.IdentifierAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.IdentifierAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.IdentifierAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.IdentifierAttri.Style;
        end;
    1:
        begin
          ColorBox1.Selected := Highlighter.CommentAttri.Foreground;
          ColorBox2.Selected := Highlighter.CommentAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.CommentAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.CommentAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.CommentAttri.Style;
        end;
    2:
        begin
          ColorBox1.Selected := Highlighter.HexAttri.Foreground;
          ColorBox2.Selected := Highlighter.HexAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.HexAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.HexAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.HexAttri.Style;
        end;
    3:
        begin
          ColorBox1.Selected := Highlighter.DirectiveAttri.Foreground;
          ColorBox2.Selected := Highlighter.DirectiveAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.DirectiveAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.DirectiveAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.DirectiveAttri.Style;
        end;
    4:
        begin
          ColorBox1.Selected := Highlighter.KeyAttri.Foreground;
          ColorBox2.Selected := Highlighter.KeyAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.KeyAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.KeyAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.KeyAttri.Style;
        end;
    5:
        begin
          ColorBox1.Selected := Highlighter.TypAttri.Foreground;
          ColorBox2.Selected := Highlighter.TypAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.TypAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.TypAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.TypAttri.Style;
        end;
    6:
        begin
          ColorBox1.Selected := Highlighter.SysAttri.Foreground;
          ColorBox2.Selected := Highlighter.SysAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.SysAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.SysAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.SysAttri.Style;
        end;
    7:
        begin
          ColorBox1.Selected := Highlighter.ModAttri.Foreground;
          ColorBox2.Selected := Highlighter.ModAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.ModAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.ModAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.ModAttri.Style;
        end;
    8:
        begin
          ColorBox1.Selected := Highlighter.NumberAttri.Foreground;
          ColorBox2.Selected := Highlighter.NumberAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.NumberAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.NumberAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.NumberAttri.Style;
        end;
    9:
        begin
          ColorBox1.Selected := Highlighter.SpaceAttri.Foreground;
          ColorBox2.Selected := Highlighter.SpaceAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.SpaceAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.SpaceAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.SpaceAttri.Style;
        end;
    10:
        begin
          ColorBox1.Selected := Highlighter.StringAttri.Foreground;
          ColorBox2.Selected := Highlighter.StringAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.StringAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.StringAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.StringAttri.Style;
        end;
    11:
        begin
          ColorBox1.Selected := Highlighter.AnsiStringAttri.Foreground;
          ColorBox2.Selected := Highlighter.AnsiStringAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.AnsiStringAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.AnsiStringAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.AnsiStringAttri.Style;
        end;
    12:
        begin
          ColorBox1.Selected := Highlighter.SymbolAttri.Foreground;
          ColorBox2.Selected := Highlighter.SymbolAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.SymbolAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.SymbolAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.SymbolAttri.Style;
        end;
    13:
        begin
          ColorBox1.Selected := Highlighter.SpecialAttri.Foreground;
          ColorBox2.Selected := Highlighter.SpecialAttri.Background;
          CheckBox1.Checked  := fsUnderline in Highlighter.SpecialAttri.Style;
          CheckBox2.Checked  := fsBold in Highlighter.SpecialAttri.Style;
          CheckBox3.Checked  := fsItalic in Highlighter.SpecialAttri.Style;
        end;
  end;
end;

procedure TOptions.ShowPanel(n: integer);
var
  i,j: integer;
begin
  j := -1;
  for i:=0 to ControlCount-1 do
    if Controls[i] is TPanel then begin
      if (TPanel(Controls[i]).tag <> n) and Controls[i].visible then
        Controls[i].visible := false
      else if TPanel(Controls[i]).tag = n then
        j := i;
    end;
  if j>-1 then Controls[j].visible := true;
end;

procedure TOptions.TreeView2Change(Sender: TObject; Node: TTreeNode);
var
  idx: integer;
begin
  case Node.AbsoluteIndex of
    0: idx := 1;
    2: idx := 3;
  else
    idx := Node.AbsoluteIndex;
  end;
  ShowPanel(idx);
end;

procedure TOptions.Button2Click(Sender: TObject);
begin
  SelectDirectoryDialog1.InitialDir := ExtractFilePath(ParamStr(0));
  if SelectDirectoryDialog1.Execute then Edit1.Text := SelectDirectoryDialog1.FileName+DirectorySeparator;
end;

procedure TOptions.Button3Click(Sender: TObject);
begin
  SelectDirectoryDialog1.InitialDir := ExtractFilePath(ParamStr(0));
  if SelectDirectoryDialog1.Execute then Edit2.Text := SelectDirectoryDialog1.FileName+DirectorySeparator;
end;

end.

